PGREP(1)

BEZEICHNUNG
pgrep, pkill, pidwait - look up, signal, or wait for processes based on name and other attributes

ÜBERSICHT
pgrep [Optionen] Muster
pkill [Optionen] Muster
pidwait [options] pattern

BESCHREIBUNG
pgrep durchsucht die gegenwärtig laufenden Prozesse und listet die Prozesskennungen (IDs), welche den Auswahlkriterien entsprechen, in der Standardausgabe auf. Übereinstimmungen sind für alle Auswahlkriterien erforderlich. Beispielsweise listet

    $ pgrep -u root sshd

nur die Prozesse auf, deren Name sshd lautet UND root gehören. Andererseits listet

    $ pgrep -u root,daemon

jene Prozesse auf, die entweder root ODER daemon gehören.

pkill sendet das angegebene Signal (per Vorgabe SIGTERM) an jeden Prozess, anstatt diese in der Standardausgabe aufzulisten.

pidwait will wait for each process instead of listing them on stdout.

OPTIONEN

-Signal
--signal Signal
    definiert das Signal, das an jeden passenden Prozess gesendet werden soll. Es werden entweder numerische Angaben oder der symbolische Signalname akzeptiert (nur für pkill).

-c, --count
    Suppress normal output; instead print a count of matching processes. When count does not match anything, e.g. returns zero, the command will return non-zero value. Note that for pkill and pidwait, the count is the number of matching processes, not the processes that were successfully signaled or waited for.

-d, --delimiter Trenner
    legt die in der Ausgabe als Trenner für die Prozesskennungen zu verwendende Zeichenkette fest. Vorgabe ist ein Zeilenumbruch (gilt nur für pgrep).

-e, --echo
    zeigt Name und Prozesskennung des zu killenden Prozesses an (nur für pkill).

-f, --full
    Das Muster wird normalerweise nur auf den Prozessnamen angewendet. Wenn -f gesetzt ist, wird die vollständige Befehlszeile verwendet.

-g, --pgroup Prozessgruppe, …
    Only match processes in the process group IDs listed. Process group 0 is translated into pgrep's, pkill's, or pidwait's own process group.

-G, --group Gruppenkennung, …
    berücksichtigt nur Prozesse, deren reale Gruppenkennung aufgelistet ist. Hier kann entweder der numerische oder der symbolische Wert verwendet werden.

-i, --ignore-case
    ignoriert Groß-/Kleinschreibung bei der Suche.

-l, --list-name
    listet sowohl den Prozessnamen als auch die Prozesskennung auf (nur für pgrep).

-a, --list-full
    listet sowohl die vollständige Befehlszeile als auch die Prozesskennung auf (nur für pgrep).

-n, --newest
    wählt nur den neuesten (zuletzt gestarteten) aus den passenden Prozessen aus.

-o, --oldest
    wählt nur den ältesten (zuerst gestarteten) aus den passenden Prozessen aus.

-O, --older Sekunden
    wählt Prozesse aus, die älter als die angegebene Anzahl Sekunden sind.

-P, --parent Eltern-Prozesskennung, …
    sucht nur nach Prozessen, von denen die Kennung des übergeordneten Prozesses aufgelistet ist.

-s, --session Sitzungskennung, …
    Only match processes whose process session ID is listed. Session ID 0 is translated into pgrep's, pkill's, or pidwait's own session ID.

-t, --terminal Terminal, …
    sucht nur nach passenden Prozessen, deren steuerndes Terminal aufgelistet ist. Der Terminalname sollte ohne das Präfix »dev« angegeben werden.

-u, --euid effektive_Benutzerkennung, …
    sucht nur nach passenden Prozessen, deren effektive Benutzerkennung aufgelistet ist. Sie können entweder numerische oder symbolische Werte verwenden.

-U, --uid Benutzerkennung, …
    sucht nur nach passenden Prozessen, deren reale Benutzerkennung aufgelistet ist. Sie können entweder numerische oder symbolische Werte verwenden.

-v, --inverse
    Negates the matching. This option is usually used in pgrep's or pidwait's context. In pkill's context the short option is disabled to avoid accidental usage of the option.

-w, --lightweight
    Shows all thread ids instead of pids in pgrep's or pidwait's context. In pkill's context this option is disabled.

-x, --exact
    sucht nur nach passenden Prozessen, deren Namen (oder Befehlszeilen, falls -f angegeben ist) exakt dem Muster entsprechen.

-F, --pidfile Datei
    Read PIDs from file. This option is more useful for pkillorpidwait than pgrep.

-L, --logpidfile
    schlägt fehl, wenn die PID-Datei (siehe -F) nicht gesperrt ist.

-r, --runstates D,R,S,Z, …
    sucht nur nach Prozessen, die diesem Prozessstatus entsprechen.

--cgroup name,...
    Match on provided control group (cgroup) v2 name. See cgroups(8)

--ns Prozesskennung
    sucht nach passenden Prozessen, die zu den gleichen Namensräumen gehören. Um Prozesse anderer Benutzer zu finden, sind Root-Rechte erforderlich. In --nslist finden Sie Informationen, wie Sie die Übereinstimmungen im Zusammenhang mit Namensräumen begrenzen können.

--nslist Name, …
    sucht nur in den angegebenen Namensräumen nach Übereinstimmungen. Verfügbare Namensräume: ipc, mnt, net, pid, user, uts.

-q, --queue Wert
    verwendet sigqueue(3) anstatt kill(2) und das Wert-Argument wird zur Angabe einer Ganzzahl verwendet, die mit dem Signal gesendet wird. Falls der empfangende Prozess mit dem SA_SIGINFO-Flag für sigaction(2) einen Handler für dieses Signal installiert hat, dann kann er diese Daten über das si_value-Feld der Struktur siginfo_t beziehen.

-V, --version
    zeigt Versionsinformationen an und beendet das Programm.

-h, --help
    zeigt eine Hilfe an und beendet das Programm.

OPERANDEN

Muster
    gibt einen erweiterten regulären Ausdruck für die Übereinstimmungen von Prozessnamen oder Befehlszeilen an.

BEISPIELE
Beispiel 1: Prozesskennung des named-Daemons suchen:

    $ pgrep -u root named

Beispiel 2: syslog veranlassen, seine Konfigurationsdatei neu einzulesen:

    $ pkill -HUP syslogd

Beispiel 3: Detaillierte Informationen zu allen xterm-Prozessen ausgeben:

    $ ps -fp $(pgrep -d, -x xterm)

Beispiel 4: Den Nice-Wert für alle chrome-Prozesse erhöhen:

    $ renice +4 $(pgrep chrome)

EXIT-STATUS
0   One or more processes matched the criteria. For pkill and pidwait, one or more processes must also have been successfully signalled or waited for.
1   Es wurden keine passenden Prozesse gefunden oder an keine von ihnen konnte ein Signal gesendet werden.
2   Syntaxfehler in der Befehlszeile.
3   Schwerwiegender Fehler: Speicher ausgeschöpft usw.

ANMERKUNGEN
The process name used for matching is limited to the 15 characters present in the output of /proc/pid/stat. Use the -f option to match against the complete command line, /proc/pid/cmdline. Threads may not have the same process name as the parent process but will have the same command line.

The running pgrep, pkill, or pidwait process will never report itself as a match.

The -O --older option will silently fail if /proc is mounted with the subset=pid option.

FEHLER
Die Optionen -n, -o und -v können nicht kombiniert werden. Bitte informieren Sie die Entwickler, falls das für Ihre Zwecke nötig sein sollte.

Bereits beendete Prozesse werden gemeldet.

SIEHE AUCH
ps(1), regex(7), signal(7), sigqueue(3), killall(1), skill(1), kill(1), kill(2), cgroups(8)

AUTOR
Kjetil Torgrim Homme (kjetilho@ifi.uio.no)

FEHLER MELDEN
Bitte schicken Sie Fehlermeldungen (auf Englisch) an procps@freelists.org